INCLUDE SSEcode.inc

.code

SSE2One PROC
    push rax
    push rbx
    push rcx
    push rdx
    push rdi
       align 16
       mov     rdx, kd
       mov     rax, xd
       mov     rcx, yd
       mov     rbx, dsum
       mov     rdi,0                  
       movapd  xmm4, OWORD PTR [rbx]
       align 16
   lp: movapd  xmm0, OWORD PTR [rax+rdi]
       movapd  xmm1, OWORD PTR [rax+rdi+16]
       movapd  xmm2, OWORD PTR [rax+rdi+32]
       movapd  xmm3, OWORD PTR [rax+rdi+48]
       mulpd   xmm0, OWORD PTR [rcx+rdi]
       mulpd   xmm1, OWORD PTR [rcx+rdi+16]
       mulpd   xmm2, OWORD PTR [rcx+rdi+32]
       mulpd   xmm3, OWORD PTR [rcx+rdi+48]
       add     rdi,64               
       addpd   xmm4, xmm0
       addpd   xmm4, xmm1
       addpd   xmm4, xmm2
       addpd   xmm4, xmm3
       sub     rdx,8                                    
       jg      lp                   
       movapd  OWORD PTR [rbx], xmm4
    pop rdi
    pop rdx
    pop rcx
    pop rbx
    pop rax
    ret
SSE2One ENDP                      

SSEOne PROC
    push rax
    push rbx
    push rcx
    push rdx
    push rdi
       align 16
       mov     rdx, ks
       mov     rax, xd
       mov     rcx, yd
       mov     rbx, dsum
       mov     rdi,0                  
       movaps  xmm4, OWORD PTR [rbx]
       align 16
   lp: movaps  xmm0, OWORD PTR [rax+rdi]
       movaps  xmm1, OWORD PTR [rax+rdi+16]
       movaps  xmm2, OWORD PTR [rax+rdi+32]
       movaps  xmm3, OWORD PTR [rax+rdi+48]
       mulps   xmm0, OWORD PTR [rcx+rdi]
       mulps   xmm1, OWORD PTR [rcx+rdi+16]
       mulps   xmm2, OWORD PTR [rcx+rdi+32]
       mulps   xmm3, OWORD PTR [rcx+rdi+48]
       add     rdi,64               
       addps   xmm4, xmm0
       addps   xmm4, xmm1
       addps   xmm4, xmm2
       addps   xmm4, xmm3
       sub     rdx,16                
       jg      lp                   
       movaps  OWORD PTR [rbx], xmm4
    pop rdi
    pop rdx
    pop rcx
    pop rbx
    pop rax
    ret
SSEOne ENDP



SSE2Two PROC
    push rax
    push rbx
    push rcx
    push rdx
    push rdi
       align 16
       mov     rdx, kd
       mov     rax, xd
       mov     rcx, yd
       mov     rdi, 0
       align 16
   lp: movapd  xmm0, OWORD PTR [rax+rdi]
       movapd  xmm1, OWORD PTR [rax+rdi+16]
       movapd  xmm2, OWORD PTR [rax+rdi+32]
       movapd  xmm3, OWORD PTR [rax+rdi+48]
       addpd   xmm0, OWORD PTR [rcx+rdi]
       addpd   xmm1, OWORD PTR [rcx+rdi+16]
       addpd   xmm2, OWORD PTR [rcx+rdi+32]
       addpd   xmm3, OWORD PTR [rcx+rdi+48]
       movapd  OWORD PTR [rax+rdi], xmm0
       movapd  OWORD PTR [rax+rdi+16], xmm1
       movapd  OWORD PTR [rax+rdi+32], xmm2
       movapd  OWORD PTR [rax+rdi+48], xmm3
       add     rdi,64       
       sub     rdx,8        
       jg      lp                        
    pop rdi
    pop rdx
    pop rcx
    pop rbx
    pop rax
    ret
SSE2Two ENDP

SSETwo PROC
    push rax
    push rbx
    push rcx
    push rdx
    push rdi
       align 16
       mov     rdx, ks
       mov     rax, xd
       mov     rcx, yd
       mov     rdi, 0
       align 16
   lp: movaps  xmm0, OWORD PTR [rax+rdi]
       movaps  xmm1, OWORD PTR [rax+rdi+16]
       movaps  xmm2, OWORD PTR [rax+rdi+32]
       movaps  xmm3, OWORD PTR [rax+rdi+48]
       addps   xmm0, OWORD PTR [rcx+rdi]
       addps   xmm1, OWORD PTR [rcx+rdi+16]
       addps   xmm2, OWORD PTR [rcx+rdi+32]
       addps   xmm3, OWORD PTR [rcx+rdi+48]
       movaps  OWORD PTR [rax+rdi], xmm0
       movaps  OWORD PTR [rax+rdi+16], xmm1
       movaps  OWORD PTR [rax+rdi+32], xmm2
       movaps  OWORD PTR [rax+rdi+48], xmm3
       add     rdi,64       
       sub     rdx,16        
       jg      lp
    pop rdi
    pop rdx
    pop rcx
    pop rbx
    pop rax
    ret
SSETwo ENDP

END

