INCLUDE SSEcode.inc

.code

SSEAMa PROC
    push rax
    push rdx
    align 16
    mov  rax,   xmmSave
    movapd  OWORD PTR [rax], xmm6
    movapd  OWORD PTR [rax+16], xmm7
       mov      rdx,  rm
       mov      rax,  spData;
       movaps   xmm0, [rax]
       movaps   xmm1, xmm0
       movaps   xmm2, xmm0
       movaps   xmm3, xmm0
       movaps   xmm4, [rax+16]
       movaps   xmm5, [rax+32]
       movaps   xmm6, [rax+48]
       movaps   xmm7, [rax+64]
       align 16
  lp1: mulps    xmm0, xmm4
       mulps    xmm1, xmm4
       mulps    xmm2, xmm4
       mulps    xmm3, xmm4
       mulps    xmm0, xmm5
       mulps    xmm1, xmm5
       mulps    xmm2, xmm5
       mulps    xmm3, xmm5   
       addps    xmm0, xmm6
       addps    xmm1, xmm6
       addps    xmm2, xmm6
       addps    xmm3, xmm6   
       addps    xmm0, xmm7
       addps    xmm1, xmm7
       addps    xmm2, xmm7
       addps    xmm3, xmm7
       mulps    xmm0, xmm4
       mulps    xmm1, xmm4
       mulps    xmm2, xmm4
       mulps    xmm3, xmm4
       mulps    xmm0, xmm5
       mulps    xmm1, xmm5
       mulps    xmm2, xmm5
       mulps    xmm3, xmm5   
       addps    xmm0, xmm6
       addps    xmm1, xmm6
       addps    xmm2, xmm6
       addps    xmm3, xmm6   
       addps    xmm0, xmm7
       addps    xmm1, xmm7
       addps    xmm2, xmm7
       addps    xmm3, xmm7
       dec      rdx
       jg       lp1
       movaps   [rax],    xmm0
       movaps   [rax+16], xmm1
       movaps   [rax+32], xmm2
       movaps   [rax+48], xmm3
    mov  rax,   xmmSave
    movapd  xmm6, OWORD PTR [rax]
    movapd  xmm7, OWORD PTR [rax+16]
    pop rdx
    pop rax
    ret
SSEAMa ENDP 

CacheSSE1a PROC
    push rax
    push rbx
    push rdx
    align 16
    mov  rax,    xmmSave
    movapd  OWORD PTR [rax], xmm6
    movapd  OWORD PTR [rax+16], xmm7
        mov      rax,  spRand
        mov      rbx,  jrx
        add      rax,  rbx
        movaps   xmm0, [rax]
        movaps   xmm1, [rax+16]
        movaps   xmm2, [rax+32]
        movaps   xmm3, [rax+48]
        movaps   xmm4, [rax+64]
        movaps   xmm5, [rax+80]
        movaps   xmm6, [rax+96]
        movaps   xmm7, [rax+112]
        mov      rax,  spData
        mov      rbx,  ix
        add      rax,  rbx
        mov      rdx,  lp
        align 16
  lp1:  mulps    xmm0, [rax+0]
        mulps    xmm1, [rax+16]
        mulps    xmm2, [rax+32]
        mulps    xmm3, [rax+48]
        mulps    xmm4, [rax+64]
        mulps    xmm5, [rax+80]
        mulps    xmm6, [rax+96]
        mulps    xmm7, [rax+112]
        mulps    xmm0, [rax+128]
        mulps    xmm1, [rax+144]
        mulps    xmm2, [rax+160]
        mulps    xmm3, [rax+176]
        mulps    xmm4, [rax+192]
        mulps    xmm5, [rax+208]
        mulps    xmm6, [rax+224]
        mulps    xmm7, [rax+240]
        addps    xmm0, [rax+256]
        addps    xmm1, [rax+272]
        addps    xmm2, [rax+288]
        addps    xmm3, [rax+304]
        addps    xmm4, [rax+320]
        addps    xmm5, [rax+336]
        addps    xmm6, [rax+352]
        addps    xmm7, [rax+368]
        addps    xmm0, [rax+384]
        addps    xmm1, [rax+400]
        addps    xmm2, [rax+416]
        addps    xmm3, [rax+432]
        addps    xmm4, [rax+448]
        addps    xmm5, [rax+464]
        addps    xmm6, [rax+480]
        addps    xmm7, [rax+496]      
        dec      rdx
        jg       lp1
        mov      rax,  spResults
        mov      rbx,  jrx
        add      rax,  rbx
        movaps   [rax],    xmm0
        movaps   [rax+16], xmm1
        movaps   [rax+32], xmm2
        movaps   [rax+48], xmm3
        movaps   [rax+64], xmm4
        movaps   [rax+80], xmm5
        movaps   [rax+96], xmm6
        movaps   [rax+112], xmm7
    mov  rax,    xmmSave
    movapd  xmm6, OWORD PTR [rax]
    movapd  xmm7, OWORD PTR [rax+16]
    pop rdx
    pop rbx
    pop rax
    ret
CacheSSE1a ENDP


RAMSSE1a PROC
    push rax
    push rdx
    align 16
    mov  rax,    xmmSave
    movapd  OWORD PTR [rax], xmm6
    movapd  OWORD PTR [rax+16], xmm7
        mov      rax,  spRand
        mov      rdx,  jdd
        add      rax,  rdx
        movaps   xmm0, [rax]
        movaps   xmm1, [rax+16]
        movaps   xmm2, [rax+32]
        movaps   xmm3, [rax+48]
        movaps   xmm4, [rax+64]
        movaps   xmm5, [rax+80]
        movaps   xmm6, [rax+96]
        movaps   xmm7, [rax+112]
        mov      rax,  spData
        mov      rdx,  count
        align 16
   lp1: movaps   [rax],     xmm0
        movaps   [rax+16],  xmm1
        movaps   [rax+32],  xmm2
        movaps   [rax+48],  xmm3
        movaps   [rax+64],  xmm4
        movaps   [rax+80],  xmm5
        movaps   [rax+96],  xmm6
        movaps   [rax+112], xmm7
        add      rax, 128
        dec      rdx
        jg       lp1
        mov      rax,  spData
        movaps   xmm0, [rax]
        movaps   xmm1, [rax+16]
        movaps   xmm2, [rax+32]
        movaps   xmm3, [rax+48]
        movaps   xmm4, [rax+64]
        movaps   xmm5, [rax+80]
        movaps   xmm6, [rax+96]
        movaps   xmm7, [rax+112]
        mov      rax,  spRand
        mov      rdx,  jdd
        add      rax,  rdx
        subps    xmm0, [rax]
        subps    xmm1, [rax+16]
        subps    xmm2, [rax+32]
        subps    xmm3, [rax+48]
        subps    xmm4, [rax+64]
        subps    xmm5, [rax+80]
        subps    xmm6, [rax+96]
        subps    xmm7, [rax+112]
        addps    xmm0, xmm1
        addps    xmm0, xmm2
        addps    xmm0, xmm3
        addps    xmm0, xmm4
        addps    xmm0, xmm5
        addps    xmm0, xmm6
        addps    xmm0, xmm7
        mov      rax,  spResults
        movaps   [rax], xmm0
    mov  rax,    xmmSave
    movapd  xmm6, OWORD PTR [rax]
    movapd  xmm7, OWORD PTR [rax+16]
    pop rdx
    pop rax
    ret
RAMSSE1a ENDP

RAMSSE1b PROC
    push rax
    push rcx
    push rdx
    align 16
     mov      rax, xmmSave
     movapd  OWORD PTR [rax], xmm6
     movapd  OWORD PTR [rax+16], xmm7
     mov      rax,  spResults
     movaps   xmm0, [rax]
     movaps   xmm1, xmm0
     movaps   xmm2, xmm0
     movaps   xmm3, xmm0
     movaps   xmm4, xmm0
     movaps   xmm5, xmm0
     movaps   xmm6, xmm0
     movaps   xmm7, xmm0
     mov      rcx, runMult
lp3: mov      rax,  spData
     mov      rdx,  count2
     align 16
lp2: addps    xmm0, [rax]
     addps    xmm1, [rax+16]
     addps    xmm2, [rax+32]
     addps    xmm3, [rax+48]
     addps    xmm4, [rax+64]
     addps    xmm5, [rax+80]
     addps    xmm6, [rax+96]
     addps    xmm7, [rax+112]
     subps    xmm0, [rax+128]
     subps    xmm1, [rax+144]
     subps    xmm2, [rax+160]
     subps    xmm3, [rax+176]
     subps    xmm4, [rax+192]
     subps    xmm5, [rax+208]
     subps    xmm6, [rax+224]
     subps    xmm7, [rax+240]
     add      rax, 256
     dec      rdx
     jg       lp2
     dec      rcx
     jg       lp3
     addps    xmm0, xmm1
     addps    xmm0, xmm2
     addps    xmm0, xmm3
     addps    xmm0, xmm4
     addps    xmm0, xmm5
     addps    xmm0, xmm6
     addps    xmm0, xmm7
     mov      rax,  spResults
     movaps   [rax], xmm0
    mov       rax, xmmSave
    movapd  xmm6, OWORD PTR [rax]
    movapd  xmm7, OWORD PTR [rax+16]
    pop rdx
    pop rcx
    pop rax
    ret
RAMSSE1b ENDP


SSE2AMa PROC
    push rax
    push rdx
    align 16
    mov     rax, xmmSave
    movapd  OWORD PTR [rax], xmm6
    movapd  OWORD PTR [rax+16], xmm7
       mov      rdx,  rm
       mov      rax,  dpData;
       movapd   xmm0, [rax]
       movapd   xmm1, xmm0
       movapd   xmm2, xmm0
       movapd   xmm3, xmm0
       movapd   xmm4, [rax+16]
       movapd   xmm5, [rax+32]
       movapd   xmm6, [rax+48]
       movapd   xmm7, [rax+64]
       align 16
  lp1: mulpd    xmm0, xmm4
       mulpd    xmm1, xmm4
       mulpd    xmm2, xmm4
       mulpd    xmm3, xmm4
       mulpd    xmm0, xmm5
       mulpd    xmm1, xmm5
       mulpd    xmm2, xmm5
       mulpd    xmm3, xmm5   
       addpd    xmm0, xmm6
       addpd    xmm1, xmm6
       addpd    xmm2, xmm6
       addpd    xmm3, xmm6   
       addpd    xmm0, xmm7
       addpd    xmm1, xmm7
       addpd    xmm2, xmm7
       addpd    xmm3, xmm7
       mulpd    xmm0, xmm4
       mulpd    xmm1, xmm4
       mulpd    xmm2, xmm4
       mulpd    xmm3, xmm4
       mulpd    xmm0, xmm5
       mulpd    xmm1, xmm5
       mulpd    xmm2, xmm5
       mulpd    xmm3, xmm5   
       addpd    xmm0, xmm6
       addpd    xmm1, xmm6
       addpd    xmm2, xmm6
       addpd    xmm3, xmm6   
       addpd    xmm0, xmm7
       addpd    xmm1, xmm7
       addpd    xmm2, xmm7
       addpd    xmm3, xmm7
       dec      rdx
       jg       lp1
       movapd   [rax],    xmm0
       movapd   [rax+16], xmm1
       movapd   [rax+32], xmm2
       movapd   [rax+48], xmm3
    mov     rax, xmmSave
    movapd  xmm6, OWORD PTR [rax]
    movapd  xmm7, OWORD PTR [rax+16]
    pop rdx
    pop rax
    ret
SSE2AMa ENDP                      

CacheSSE2a PROC
    push rax
    push rbx
    push rdx
    align 16
    mov     rax,  xmmSave
    movapd  OWORD PTR [rax], xmm6
    movapd  OWORD PTR [rax+16], xmm7
        mov      rax,  dpRand
        mov      rbx,  jrx
        add      rax,  rbx
        movapd   xmm0, [rax]
        movapd   xmm1, [rax+16]
        movapd   xmm2, [rax+32]
        movapd   xmm3, [rax+48]
        movapd   xmm4, [rax+64]
        movapd   xmm5, [rax+80]
        movapd   xmm6, [rax+96]
        movapd   xmm7, [rax+112]
        mov      rax,  dpData
        mov      rbx,  ix
        add      rax,  rbx
        mov      rdx,  lp
        align 16
  lp1:  mulpd    xmm0, [rax+0]
        mulpd    xmm1, [rax+16]
        mulpd    xmm2, [rax+32]
        mulpd    xmm3, [rax+48]
        mulpd    xmm4, [rax+64]
        mulpd    xmm5, [rax+80]
        mulpd    xmm6, [rax+96]
        mulpd    xmm7, [rax+112]
        mulpd    xmm0, [rax+128]
        mulpd    xmm1, [rax+144]
        mulpd    xmm2, [rax+160]
        mulpd    xmm3, [rax+176]
        mulpd    xmm4, [rax+192]
        mulpd    xmm5, [rax+208]
        mulpd    xmm6, [rax+224]
        mulpd    xmm7, [rax+240]
        addpd    xmm0, [rax+256]
        addpd    xmm1, [rax+272]
        addpd    xmm2, [rax+288]
        addpd    xmm3, [rax+304]
        addpd    xmm4, [rax+320]
        addpd    xmm5, [rax+336]
        addpd    xmm6, [rax+352]
        addpd    xmm7, [rax+368]
        addpd    xmm0, [rax+384]
        addpd    xmm1, [rax+400]
        addpd    xmm2, [rax+416]
        addpd    xmm3, [rax+432]
        addpd    xmm4, [rax+448]
        addpd    xmm5, [rax+464]
        addpd    xmm6, [rax+480]
        addpd    xmm7, [rax+496]      
        dec      rdx
        jg       lp1
        mov      rax,  dpResults
        mov      rbx,  jrx
        add      rax,  rbx
        movapd   [rax],    xmm0
        movapd   [rax+16], xmm1
        movapd   [rax+32], xmm2
        movapd   [rax+48], xmm3
        movapd   [rax+64], xmm4
        movapd   [rax+80], xmm5
        movapd   [rax+96], xmm6
        movapd   [rax+112], xmm7
    mov     rax, xmmSave
    movapd  xmm6, OWORD PTR [rax]
    movapd  xmm7, OWORD PTR [rax+16]
    pop rdx
    pop rbx
    pop rax
    ret
CacheSSE2a ENDP

RAMSSE2a PROC
    push rax
    push rdx
    align 16
    mov     rax, xmmSave
    movapd  OWORD PTR [rax], xmm6
    movapd  OWORD PTR [rax+16], xmm7
        mov      rax,  dpRand
        mov      rdx,  jdd
        add      rax,  rdx
        movapd   xmm0, [rax]
        movapd   xmm1, [rax+16]
        movapd   xmm2, [rax+32]
        movapd   xmm3, [rax+48]
        movapd   xmm4, [rax+64]
        movapd   xmm5, [rax+80]
        movapd   xmm6, [rax+96]
        movapd   xmm7, [rax+112]
        mov      rax,  dpData
        mov      rdx,  count
        align 16
   lp1: movapd   [rax],     xmm0
        movapd   [rax+16],  xmm1
        movapd   [rax+32],  xmm2
        movapd   [rax+48],  xmm3
        movapd   [rax+64],  xmm4
        movapd   [rax+80],  xmm5
        movapd   [rax+96],  xmm6
        movapd   [rax+112], xmm7
        add      rax, 128
        dec      rdx
        jg       lp1
        mov      rax,  dpData
        movapd   xmm0, [rax]
        movapd   xmm1, [rax+16]
        movapd   xmm2, [rax+32]
        movapd   xmm3, [rax+48]
        movapd   xmm4, [rax+64]
        movapd   xmm5, [rax+80]
        movapd   xmm6, [rax+96]
        movapd   xmm7, [rax+112]
        mov      rax,  dpRand
        mov      rdx,  jdd
        add      rax,  rdx
        subpd    xmm0, [rax]
        subpd    xmm1, [rax+16]
        subpd    xmm2, [rax+32]
        subpd    xmm3, [rax+48]
        subpd    xmm4, [rax+64]
        subpd    xmm5, [rax+80]
        subpd    xmm6, [rax+96]
        subpd    xmm7, [rax+112]
        addpd    xmm0, xmm1
        addpd    xmm0, xmm2
        addpd    xmm0, xmm3
        addpd    xmm0, xmm4
        addpd    xmm0, xmm5
        addpd    xmm0, xmm6
        addpd    xmm0, xmm7
        mov      rax,  dpResults
        movapd   [rax], xmm0
    mov     rax, xmmSave
    movapd  xmm6, OWORD PTR [rax]
    movapd  xmm7, OWORD PTR [rax+16]
    pop rdx
    pop rax
    ret
RAMSSE2a ENDP

RAMSSE2b PROC
    push rax
    push rcx
    push rdx
    align 16
    mov     rax, xmmSave
    movapd  OWORD PTR [rax], xmm6
    movapd  OWORD PTR [rax+16], xmm7
        mov      rax,  dpResults
        movapd   xmm0, [rax]
        movapd   xmm1, xmm0
        movapd   xmm2, xmm0
        movapd   xmm3, xmm0
        movapd   xmm4, xmm0
        movapd   xmm5, xmm0
        movapd   xmm6, xmm0
        movapd   xmm7, xmm0
        mov      rcx,  runMult
   lp3: mov      rax,  dpData
        mov      rdx,  count2
        align 16
   lp2: addpd    xmm0, [rax]
        addpd    xmm1, [rax+16]
        addpd    xmm2, [rax+32]
        addpd    xmm3, [rax+48]
        addpd    xmm4, [rax+64]
        addpd    xmm5, [rax+80]
        addpd    xmm6, [rax+96]
        addpd    xmm7, [rax+112]
        subpd    xmm0, [rax+128]
        subpd    xmm1, [rax+144]
        subpd    xmm2, [rax+160]
        subpd    xmm3, [rax+176]
        subpd    xmm4, [rax+192]
        subpd    xmm5, [rax+208]
        subpd    xmm6, [rax+224]
        subpd    xmm7, [rax+240]
        add      rax, 256
        dec      rdx
        jg       lp2
        dec      rcx
        jg       lp3
        addpd    xmm0, xmm1
        addpd    xmm0, xmm2
        addpd    xmm0, xmm3
        addpd    xmm0, xmm4
        addpd    xmm0, xmm5
        addpd    xmm0, xmm6
        addpd    xmm0, xmm7
        mov      rax,  dpResults
        movapd   [rax], xmm0
    mov     rax, xmmSave
    movapd  xmm6, OWORD PTR [rax]
    movapd  xmm7, OWORD PTR [rax+16]
    pop rdx
    pop rcx
    pop rax
    ret
RAMSSE2b ENDP                      


END

